/* Calculate a runnning sum for a second */
/* expects single input and a single output argument */
void rsum(double *in, int ins, double *out, int outs) {
        /* Initalize static variables, buffer elemts at zero initially */
        static double buf[CYCLE_PER_SECOND] = { [0 ... CYCLE_PER_SECOND-1]
= 0.0 };
        static double *inp = buf+1;
        static double *outp = buf;
        static double rsum = 0.0;       /* Do we need to worry about error
accumulation ? */

        *outp++ = *in;  /* Store new sample int the buffer and increment
pointer */
        rsum += *in;    /* Add new sample to the sum */
        rsum -= *inp++; /* Subtract the oldest sample from the sum and
increment pointer */
        if (outp == (buf + CYCLE_PER_SECOND - 1)) outp = buf;   /* Roll
over if reached the end */
        if (inp == (buf + CYCLE_PER_SECOND - 1)) inp = buf;     /* Ditto
*/
        *out = rsum;    /* Return the current sum */
}